/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.contribution.ContributedTab"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojox.data.dom"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler"); //$NON-NLS-1$

(function() {

var ResponseHandler= com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler;

dojo.declare("com.ibm.team.apt.web.ui.contribution.ContributedTab", //$NON-NLS-1$
			 [dijit._Widget], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_iterationPlanPage: null,
	_serviceCallController: null,

	// ---- implementing class api -----------------------------------------------------------------------------------------	


	getPlanItem: function() {
		return this._iterationPlanPage._iterationPlanDTO;
	},

	getPlanIteration: function() {
		return this._iterationPlanPage._iterationPlanDTO.getIteration();
	},
	
	getPlanIncludedIterations: function() {
		return this._iterationPlanPage.getIncludedIterations();
	}, 

	getPlanIncludedTeamMemberAreas: function() {
		return this._iterationPlanPage.getIncludedTeamMemberAreas();
	}, 

	getPlanTeamArea: function() {
		return this._iterationPlanPage._iterationPlanDTO.getTeamArea();
	},

	getResponseHandler: function(contextObject, callbackName, errorCallbackName, label) {
		var responseHandler= new ResponseHandler(contextObject, callbackName, errorCallbackName);
		responseHandler.setLabel(label, this._serviceCallController);		
		return responseHandler;
	},

	handleRemoteError: function(error) {
		this._serviceCallController.remoteError(error);
	},

	// ---- widget lifecycle hooks -----------------------------------------------------------------------------------------	

	onShowTab: function() {
		
	},

//	onHideTab: function() {
//		
//	},

	__sentinel: null // terminates this class definition
});

/**
 * This helper method creates the arguments object for the widget's constructor.
 * @return {Object} a widget private object to be passed in as a constructor argument
 */
com.ibm.team.apt.web.ui.contribution.ContributedTab.constructorArgs= function(iterationPlanPage, serviceCallController) {
	return {
		_iterationPlanPage: iterationPlanPage,
		_serviceCallController: serviceCallController
	};
};

})();
