/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.build.web.ui.internal.MetaNav");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.build.web.util.BuildUtil");
dojo.require("com.ibm.team.build.web.ui.internal.utils.ResultUtil");
dojo.require("jazz.ui.internal.SimpleToolbar");
dojo.require("jazz.ui.Breadcrumbs");

dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.build.web.ui.internal", "BuildMessages");
dojo.require("dojox.data.dom");

(function(){

var BuildUtil = com.ibm.team.build.web.util.BuildUtil;
var ResultUtil = com.ibm.team.build.web.ui.internal.utils.ResultUtil;

var messages = dojo.i18n.getLocalization("com.ibm.team.build.web.ui.internal", "BuildMessages");

dojo.declare("com.ibm.team.build.web.ui.internal.MetaNav",
	[dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("com.ibm.team.build.web", "ui/internal/templates/MetaNav.html"),
	
	widgetsInTemplate: true,
	
	constructor: function(args) {
		this.loading = messages.loading;
	},
	
	setTitle: function(title) {
		// consumers of setTitle are responsible for escaping the parameter themselves
		this.heading.innerHTML = title;
		dojo.removeClass(this.heading, "loading");
	},
	
	populateBreadcrumbs: function(definition, result) {
		// breadcrumbs widget inserts text nodes, so labels do not need escaping
		this.breadcrumbs.segments = [];
		this.breadcrumbs.segments.push({ label: messages.buildDefinitions, href: BuildUtil.getDefinitionListHref() })
		if (definition)
			this.breadcrumbs.segments.push({label: definition.id, href: BuildUtil.getDefinitionHref(definition.itemId)});
		if (result)
			this.breadcrumbs.segments.push({label: ResultUtil.getLabel(result), href: BuildUtil.getResultHref(result.buildResult.itemId)});
		this.breadcrumbs.refresh();
	},
	
	clearMessage: function () {
		dojox.data.dom.removeChildren(this.messageBox);
		this.messageBox.innerText = " ";
		this.messageBox.className = "";
	},
	
	displayErrorMessage: function (msg) {
		this.displayMessage(msg, "errorMsg");
	},
	displayMessage: function (msg, cssClass) {
		this.clearMessage();
		this.messageBox.className = cssClass;
		this.messageBox.appendChild(document.createTextNode(msg));
	}
});

})();
