/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportParamFactory");

dojo.require("com.ibm.team.reports.web.ui.internal.ReportParamSingleSelect");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportParamMultiSelect");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportParamBoolean");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportParamEditBox");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportParamDate");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportParamTime");
dojo.require("com.ibm.team.reports.web.ui.internal.ReportParamDateTime");

(function() {
	
	var KIND_ANY = 0;
	var KIND_STRING = 1;
	var KIND_FLOAT = 2;
	var KIND_DECIMAL = 3;
	var KIND_DATE_TIME = 4;
	var KIND_BOOLEAN = 5;
	var KIND_INTEGER = 6;
	var KIND_DATE = 7;
	var KIND_TIME = 8;
	
	var DISPLAY_UNSPECIFIED = 0;
	var DISPLAY_SINGLE_SELECT_LIST = 1;
	var DISPLAY_MULTI_SELECT_LIST = 2;
	var DISPLAY_EDIT_BOX = 3;
   
	function create(parameterDTO, urlPrefix) {
		switch (parameterDTO.kind) {
			case KIND_STRING:
			case KIND_INTEGER:
			case KIND_FLOAT:
			case KIND_DECIMAL:
				switch (parameterDTO.display) {
					case DISPLAY_SINGLE_SELECT_LIST:
						return new com.ibm.team.reports.web.ui.internal.ReportParamSingleSelect({parameterDTO: parameterDTO, urlPrefix: urlPrefix});
						break;
					case DISPLAY_MULTI_SELECT_LIST:
						return new com.ibm.team.reports.web.ui.internal.ReportParamMultiSelect({parameterDTO: parameterDTO, urlPrefix: urlPrefix});
						break;
					case DISPLAY_EDIT_BOX:
						return new com.ibm.team.reports.web.ui.internal.ReportParamEditBox({parameterDTO: parameterDTO, urlPrefix: urlPrefix});
						break;
				}
				break;
			case KIND_BOOLEAN:
				return new com.ibm.team.reports.web.ui.internal.ReportParamBoolean({parameterDTO: parameterDTO, urlPrefix: urlPrefix});
				break;
			case KIND_DATE:
				return new com.ibm.team.reports.web.ui.internal.ReportParamDate({parameterDTO: parameterDTO, urlPrefix: urlPrefix});
				break;
			case KIND_TIME:
				return new com.ibm.team.reports.web.ui.internal.ReportParamTime({parameterDTO: parameterDTO, urlPrefix: urlPrefix});
				break;
			case KIND_DATE_TIME:
				return new com.ibm.team.reports.web.ui.internal.ReportParamDateTime({parameterDTO: parameterDTO, urlPrefix: urlPrefix});
				break;
		}
	}
	
	com.ibm.team.reports.web.ui.internal.ReportParamFactory.create = create;
	
})();