/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.dnd.TabTarget");

dojo.require("jazz.ui.dnd.DraggableContainer");
dojo.require("jazz.ui.dnd.DraggableManager");

dojo.require("com.ibm.team.dashboard.web.ui.internal.Constants");

(function() {
	var Constants = com.ibm.team.dashboard.web.ui.internal.Constants;
	var draggableManager = jazz.ui.dnd.draggableManager();
	
	dojo.declare("com.ibm.team.dashboard.web.ui.internal.dnd.TabTarget", jazz.ui.dnd.DraggableContainer, {
		constructor: function(node, params){
			this.isSource = false;
			this.index = params.index;
			this.dashboardContainer = params.dashboardContainer;
		},
		destroy: function() {
			var targets = draggableManager.targets;
			for (var i = 0; i < targets.length; i++ ) {
				if (targets[i] == this) {
					targets.splice(i,1);
					break;
				}	
			}
			this.inherited(arguments);
		},
		/* Move
		 * 
		 * return: cancelDrag - true/false 
		 * 
		 */
		move: function(fromIndex, toTab) {
			var dw = draggableManager.widget;
			if (dw._viewlet && dw._viewlet.isEditing()) {
				draggableManager.stopForInput();
				if(!dw.stopEditing()) {
					return true;
				}
			}
			var fromContainer = draggableManager.fromContainer;
			var widget = fromContainer.widgets.splice(fromIndex,1)[0];
			widget.domNode.parentNode.removeChild(widget.domNode);
			
			// update model
			var viewletHelper = dw.viewletHelper;
			var fromColumnHelper = fromContainer._columnHelper;
			var toColumnHelper = this.dashboardContainer.dashboardItem.viewletPages[toTab.index].columns[0];
			fromColumnHelper.viewlets.splice(fromIndex, 1);
			if (!toColumnHelper.viewlets) {
				toColumnHelper.viewlets = [viewletHelper];
			}
			else {
				toColumnHelper.viewlets.splice(0, 0, viewletHelper);
			}
			fromContainer.propertyChanged(Constants.PROPERTY_DASHBOARD);
			
			this.dashboardContainer.setPageDirty(toTab.index);
			this.dashboardContainer.currentPage.updateEmptyPageMessage();
			this.updateIndices(fromContainer);
			widget.destroy();
			return false;
		},
		registerContainer: function() {
			draggableManager.targets.push(this);
		}
	});
})();