﻿/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
class VerticalBarYAxis extends YAxis {
	
	public function VerticalBarYAxis() {
		super();
	}	
	
	public function draw(parentMC:MovieClip, gridData:GridData):Void {
	
		super.draw(parentMC, gridData);
		
		this.mc.lineStyle(Axis.LINE_THICKNESS, Axis.LINE_COLOUR);		
		
		this.mc.moveTo(this.gridData.xZeroPosition, this.gridData.hTickOffsetY);
		this.mc.lineTo(this.gridData.xZeroPosition, this.gridData.yZeroPosition);
		
		var tickY:Number = this.gridData.hTickOffsetY;
		var label:Number = this.gridData.max;
		var locationY:Number = this.gridData.startY;
		var textFieldWidth:Number = this.gridData.yAxisMaxLabelWidth + (Constants.TEXT_FIELD_MARGIN * 2);
		
		for (var step:Number = 0; step < this.gridData.yAxisSectionCount + 1; step++) {

			// Label
			var labelID:String = YAxis.Y_AXIS_LABEL_NAME + step;
			
			this.mc.createTextField(labelID, 
									this.mc.getNextHighestDepth(), 
									this.gridData.startX, 
									locationY, 
									textFieldWidth, 
									Axis.TEXT_FIELD_HEIGHT);
			this.mc[labelID].text = label;
			this.mc[labelID].setTextFormat(YAxis.LABEL_FORMAT);
			
			label = label - this.gridData.yAxisIncrement;		
			locationY = locationY + this.gridData.yAxisSpacing;

			// Tick
			this.mc.moveTo(this.gridData.hTickOffsetX, tickY);
			this.mc.lineTo(this.gridData.xZeroPosition, tickY);		

			// Dashed line
			if (step < this.gridData.yAxisSectionCount) {
				this.drawHDashedLine(
					this.gridData.xZeroPosition, 
					tickY, 
					this.gridData.xZeroPosition + this.gridData.graphAreaWidth);
			}

			tickY = tickY + this.gridData.yAxisSpacing;
		}					
	}
		
	public function destroy():Void {
		super.destroy();
	}	
	
}
