/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
({
	// Shared
	'del': "Delete",
	'delConfirmPrivate': "Are you sure you want to delete ${0}?",
	'loading': "Loading...",
	'addViewletText': "Add Viewlet",
	'refresh': "Refresh",
	'save': "Save",
	'cancel': "Cancel",
	'allHeading': "All Dashboards",
	'clickToEdit': "Click to Edit",
	'featureNotSupported': "Your browser does not support this feature.",
	
	// Client
	'noAccessWeb': "Your account does not belong to the groups that are authorized to access the Web UI.  Please contact your server administrator.",
	
	// Dashboard Page
	'dashboardTitleWithTab': "Dashboard: ${0} > ${1}",
	'dashboardTitle': "Dashboard: ${0}",
	'allUsersTitle': "Dashboards: All Dashboards > All Users",
	'allTeamAreasTitle': "Dashboards: All Dashboards > All Team Areas",
	'dashboardsGenericTitle': "Dashboards",
	'connectionFailure': "The server may be offline or your internet connection may be down. Please check your connection and try again.",
	'errorNoPermission': "You do not have permission to view this dashboard.",
	'errorRetrieving': "An error occured while retrieving the dashboard:",
	'saveFailure': "The dashboard could not be saved because it has been independently modified in another browser. Please refresh to see the latest content.",
	'deleteNoLongerExists': "The dashboard no longer exists on the server.",
	
	// Dashboard Container
	'navigateAwayPrefix': "Are you sure you want to navigate away from this page? \n\n",
	'navigateAwaySuffix': "\n\nPress OK to continue, or Cancel to stay on the current page.",
	'unsavedWork': "You have unsaved work on the Dashboards page. ", //preserve space after the period
	'unsavedChanges': "You have unsaved changes. ", //preserve space after the period
	'editingContents': "You are currently editing one or more viewlets on the Dashboards page. ", //preserve space after the period
	'editingContentsUnload': "You are currently editing one or more viewlets. ", //preserve space after the period
	'willDiscard': "If you continue your changes will be discarded.",
	'canReturn': "You can change pages but must remember to return to Dashboards to save your changes.",
	'viewletDefinitionsError': "Unable to retrieve viewlet definitions. ", //preserve space after the period
	'viewletErrors': "One or more of the viewlets could not be loaded.",
	'restoreError': "An error occured while restoring the dashboard:\n\n${0}",
	
	// Dashboard Item
	'itemEditStaleSpecific': "This dashboard was independently modified by ${0}. Click OK to refresh and see the latest changes.",
	'itemEditStaleGeneral': "This dashboard was independently modified and needs to be reloaded. Click OK to see the latest changes.",
	'itemEditLocked': "${0} is currently editing this dashboard. Would you like to override and edit anyway? (they will be unable to save their changes)",
	'itemEditError': "An internal error occured; unable to enter edit mode: ${0}",
	'itemSaveStaleSpecific': "The dashboard could not be saved because it has been modified by ${0}. Please refresh to see the latest content.",
	'itemSaveStaleGeneral': "The dashboard could not be saved because it independently modified in another browser. Please refresh to see the latest content.",
	'itemSaveLocked': "The dashboard could not be saved because it is being edited by ${0}. Please refresh to see the latest content.",
	
	// Viewlet Page
	'addViewletRemoteError': "Add Viewlet remote error: ",
	'viewletNotFetched': "The viewlet definition could not be fetched: ",
	'noViewlets': "There are no viewlets in this tab.",
	'noViewletsAdd': "To add some, click on the <0>${0}</0> link located at the top right of the dashboard.",
	
	// Draggable Tabs
	'newTab': "New tab",
	'rename': "Rename",
	'deleteText': "Delete",
	'layout': "Layout",   // The layout of the dashboard (number of columns)
	'oneColumn': "1 Column",
	'twoColumns': "2 Columns",
	'threeColumns': "3 Columns",
	'deletingTabConfirm': "Are you sure you want to delete ${0}?",
	'deleteLastTab': "The last tab cannot be deleted.",
	
	// Viewlet Container
	'showHeader': "Show header",
	'hideHeader': "Hide header",
	'editContents': "Edit Contents",
	'edit': "Edit",
	'editSettings': "Edit Settings",
	'copyTab': "Copy Tab",
	'copyViewlet': "Copy Viewlet",
	'duplicateTab': "Duplicate Tab",
	'duplicateViewlet': "Duplicate Viewlet",
	'close': "Close",
	'closeViewlet': "Are you sure you want to close this viewlet?",
	'stopEditingConfirm': "Viewlet \"${0}\" is currently being edited.  If you continue, your changes to this viewlet will be lost. \n\nAre you sure you want to continue?",
	'zoom': "Zoom",
	'menu': "Menu",
	'expand': "Expand",
	'collapse': "Collapse",
	'viewletDefNotFound': "Viewlet definition could not be found: ${0}",
	'noPermissionName': "Permission denied",
	'viewletLogin': "You must log into ${0} to view this content.",
	'viewletLogin2': "Log In",
	'viewletNotLoggedIn': "(not logged in)",
	'viewletDeleted': "This viewlet is no longer available on the server.",
	'disconnected': "Disconnected from ${0} (${1})",
	'connected': "Connected to ${0} (${1})",
	'remoteServer': "remote server",
	'remoteConnectionError': "There was a problem connecting to the remote server.",
	
	// All Dashboards
	'allTeams': "All Team Areas",
	'allTeamsProj': "Project area:",
	'allTeamsNone': "No team areas found.",
	'allTeamsNoneMatch': "No team areas match the current filter.",
	'allUsers': "All Users",
	'allUsersRelated': "Related",
	'allUsersAll': "All",
	'allDashboardsPrev': "Previous",
	'allDashboardsNext': "Next",
	'allDashboardsOf': "of",
	'allUsersShowingSingular': "Showing ${0} user on your teams.",
	'allUsersShowingPlural': "Showing ${0} users on your teams.",
	'allUsersNoRelated': "No related users.",
	'allUsersNone': "No matching users found.",
	'allUsersNoTeamMatch': "No users on your teams match the current filter.",
	'allShared': "All Shared",
	'allSharedNone': "No shared dashboards found.",
	'allSharedSearching': "Searching dashboards",
	
	// Left Nav
	'leftPersonalTitle': "My Dashboards",
	'leftSharedTitle': "Public Dashboards",
	'leftRecentTitle': "Recently Viewed",
	'leftCreateButton': "Create Dashboard",
	'leftSearchDefaultText': "Type to search",
	'leftSearchScopeAll': "All Dashboards",
	'leftSearchScopeAllTeams': "All Team Dashboards",
	'leftSearchScopeAllShared': "All Shared Dashboards",
	'leftSearchTooltip': "Search dashboards",
	'leftSearchNoResultsLabel': "No dashboards found",
	'leftSearchError': "Error: ${0}",
	'leftSearchErrorContact': "Error contacting server",
	'leftSearchUsers': "Shared (${0})",
	
	// Meta Nav
	'connectionError':"Connection error: The server is offline or your internet connection is down. Your most recent action may not have been saved.",
	'communicationError': "An error occurred while communicating with the server.",
	'archivedContributor': "Note: The user associated with this dashboard is archived and no longer in use.",
	'archivedTeam': "Note: The team associated with this dashboard is archived and no longer in use.",
	'archivedProject': "Note: The project associated with this dashboard is archived and no longer in use.",
	'reload': "Reload",
	'autoSave': "Auto-save",
	'restoreDefault': "Restore Default",
	'confirm': "You will lose your changes.  Are you sure? \n(Click Okay to discard changes or Cancel to resume editing)",  //  "\n" is required
	'dashboardModified': "This dashboard has been modified",
	'addNewTab': "Add New Tab",
	'sharing': "Sharing Options",
	'paste': "Paste",
	'alertShareDirty': "You have unsaved changes. You need to save the dashboard before you can edit sharing options.",
	'clipboardEmpty': "You have nothing in the clipboard.",
	'shareCheckboxLabel': "Share this dashboard",
	'shareVisibility': "Make this dashboard visible to:",
	'restoreDashboard': "Are you sure you want to restore the ${0} dashboard to its template?\nWARNING: This will ERASE the current dashboard content.",
	'firebugWarning': "Firebug is known to make Dashboards slow. Disable it to improve performance.",
	
	// Viewlet Chooser
	'viewletChooser': "Viewlet Chooser",
	'selectFromChooser': "Select a viewlet from the chooser to add it to your dashboard.",
	'viewletChooserHelp': "To add viewlets from another server, contact your administrator to configure <0>cross-server communication</0>, located in the <1>Admin</1> page.",
	'viewletChooserHelpAdmin': "To add viewlets from another server, you must first configure <0>cross-server communication</0>, located in the <1>Admin</1> page.",
	'appliesTo': "Applies to:",
	'description': "Description:",
	'preview': "Preview:",
	'appliesToTeams': "Teams",
	'appliesToProjects': "Projects",
	'appliesToProjectsTeams': "Projects &amp; teams", // "&amp;" represents the "&" character and should not be translated
	'appliesToContributors': "Contributors",
	'appliesToAll': "Projects, teams &amp; contributor", // "&amp;" represents the "&" character and should not be translated
	'appliesToUnknown': "Unknown",
	'viewletPreviewImage': "Viewlet Preview Image",
	'noDescriptionSpecified': "No description was specified.",
	'missingViewletPreviewImage': "No preview available.",
	'msgRepositoryConnectionFailed': "Failed to connect to the repository.",
	'msgRepositoryDiscoveryFailed': "Failed to discover any repositories.",
	'msgIncompatible': "The current version of this server does not support remote viewlets. To fix this, please upgrade your server to a version based on Foundation 1.0.0.1.",

	// Error Page
	'dashboardErrorMessage': "An internal system error occured while retrieving the dashboard.",
	'dashboardErrorTitle': "Error!",
	
	// Viewlet Settings
	'settingsReq': "required field",
	'settingsLoadingOpts': "Loading Options...",
	'settingsAppearance': "Appearance",
	'settingsTitle': "Title",
	'settingsTitleDesc': "The text that appears in the heading area of the viewlet.",
	'settingsTitleDesc2': "Only editable when not using a computed title.",
	'settingsTitleComp': "Use computed title",
	'settingsTitleCompDesc': "Indicates whether the viewlet should automatically determine its title.",
	'settingsTrim': "Trim",
	'settingsTrimDesc': "Trim colour selection affects viewlet borders and background.",
	'settingsBackgr': "Show Background Color",
	'settingsBackgrDesc': "Indicates whether trim color should fill the background of the viewlet.",
	'settingsPrefs': "Preferences",
	'settingsPrefsEdit': "Edit...",
	'settingsScopeAll': "Scope",
	'settingsScopeUser': "User",
	'settingsScopeTeam': "Team",
	'settingsScopeProject': "Project",
	'settingsScopeProcess': "Project/Team",
	'settingsScopeSub': "Include sub-teams",
	'settingsScopeSubDesc': "Indicates whether the viewlet should include sub-teams of the selected team or project.",
	'settingsScopeNone': "None",
	'settingsScopeLabelUser': "${0} (User)",
	'settingsScopeLabelTeam': "${0} (Team)",
	'settingsScopeLabelProject': "${0} (Project)",
	
	// ErrorReport
	'errorReport': "An error occured while loading the viewlet.",
	'errorReportShowDetails': "Show details",
	'errorReportHideDetails': "Hide details",
	
	// PagedTableViewlet
	'pagedTableNext': "Next",
	'pagedTablePrev': "Previous",
	'pagedTableFirst': "First",
	'pagedTableLast': "Last",
	'pagedTableLoading': "Loading...",
	'pagedTablePageCount': "<s0>Page </s0><s1/> of <s2/>", // should be translates as "Page x of y" but the <s0> tags need to stay around "Page "
	'pagedTableNoResults': "No results available.",
	'pagedTableFetchNotOverriden': "fetch has not been overriden.",
	'pagedTablePermissionDenied': "You do not have permission to view this data."
})
