/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.viewlets.web.ui.internal.utils.URLUtility");

(function() {

com.ibm.team.workitem.viewlets.web.ui.internal.utils.URLUtility = {
	
	/*
 	* Static Variables
 	*/	
	_IE_URI_CHARACTER_LIMIT: 2083,

	/*
 	 * Public Method
 	 * 
 	 * Validate the specified url's syntax and length
 	 * 
 	 * @param String url
 	 * @return boolean
 	 */		
	isValidURL: function(url) {

		// http://support.microsoft.com/kb/208427
		// Validate url length
		if (url.length > this._IE_URI_CHARACTER_LIMIT) {
			return false;
		}

		// http://www.ietf.org/rfc/rfc1738.txt
		//   Unsafe:
		//   Characters can be unsafe for a number of reasons.  The space
		//   character is unsafe because significant spaces may disappear and
		//   insignificant spaces may be introduced when URLs are transcribed or
		//   typeset or subjected to the treatment of word-processing programs.
		//   The characters "<" and ">" are unsafe because they are used as the
		//   delimiters around URLs in free text; the quote mark (""") is used to
		//   delimit URLs in some systems.  The character "#" is unsafe and should
		//   always be encoded because it is used in World Wide Web and in other
		//   systems to delimit a URL from a fragment/anchor identifier that might
		//   follow it.  The character "%" is unsafe because it is used for
		//   encodings of other characters.  Other characters are unsafe because
		//   gateways and other transport agents are known to sometimes modify
		//   such characters. These characters are "{", "}", "|", "\", "^", "~",
		//   "[", "]", and "`".
		var pattern = /^[A-Za-z0-9_\/\$\?\-\.\+\(\),'\*!#;:@&=%]+$/i;
		// Validate url syntax	 
		var result = url.match(pattern);
		
		if (result == null) {
			return false;
		}		
		return true;
	}

};


})();

