/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.Tab"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojox.data.dom"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.ImageClient"); //$NON-NLS-1$

(function() {

var PlanningUtil		= com.ibm.team.apt.web.client.util;
var ImageClient			= com.ibm.team.apt.web.client.internal.ImageClient;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.Tab", //$NON-NLS-1$
			 [dijit._Widget], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	
	
	__tabDomNode: null,
	
	_iterationPlanPage: null,
	_title: null,
	_tabId: null,
	_serviceCallController: null,

	// ---- api ------------------------------------------------------------------------------------------------------------	

	tabNode: function(node) {
		if(node !== undefined)
			this.__tabDomNode= node;
		return this.__tabDomNode;
	},
	
	getId: function() {
		return this._tabId;
	},

	getTitle: function() {
		return this._title;
	},

	setViewOptions: function(viewOptions) {
		
	},

	getViewOptions: function() {
		return {};
	},
	
	widgetAboutToShow: function() {
		
	},
	
	destroy: function(finalize) {
		this.inherited(arguments);
		this._iterationPlanPage._removeTab(this);
		this.__tabDomNode= null;
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	postCreate: function() {

	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	_getServiceCallController: function() {
		return this._serviceCallController;
	},

	__sentinel: null // terminates this class definition
});

/**
 * This helper method creates the arguments object for the widget's constructor.
 * @param {Object} iterationPlanPage the Tab's id. must be unique to the iteration plan 
 * @param {String} id the tab's id. must be unique to the iteration plan 
 * @param {String} title The tab title text
 * @param {Object} serviceCallController A ServiceCallController object that is needed to load additional page data
 * @return {Object} a widget private object to be passed in as a constructor argument
 */
com.ibm.team.apt.web.ui.internal.view.plan.Tab.constructorArgs= function(iterationPlanPage, id, title, serviceCallController) {
	return {
		_iterationPlanPage: iterationPlanPage,
		_tabId: id,
		_title: title,
		_serviceCallController: serviceCallController
	};
};

})();
