/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$

(function() {
	
var Assert							= com.ibm.team.apt.web.ui.internal.common.Assert;

var STYLE_FLAT= 1;
var STYLE_PUSH= 2;
var STYLE_TOGGLE= 4;
var STYLE_DROP_DOWN= 8;

var STYLE_NOHOVER= 128;
var STYLE_SHOW_AS_SELECTED= 256;
var STYLE_SHOW_AS_SINGLESELECTED= 512;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action", //$NON-NLS-1$
			 null, {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getStyle: function() {
		return STYLE_FLAT;
	},
	
	getId: function() {
		Assert.isTrue(false, "subclass must implement Action#getId()"); //$NON-NLS-1$
		return ""; //$NON-NLS-1$
	},
	
	getIconUrl: function() {
		return null;
	},
	
	getName: function() {
		Assert.isTrue(false, "subclass must implement Action#getName()"); //$NON-NLS-1$
		return ""; //$NON-NLS-1$
	},
	
	isChecked: function() {
		return false;
	},
	
	canHandle: function() {
		Assert.isTrue(false, "subclass must implement Action#canHandle()");	 //$NON-NLS-1$
		return true;
	},
	
	handle: function() {
		Assert.isTrue(false, "subclass must implement Action#handle()"); //$NON-NLS-1$
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

var Action= com.ibm.team.apt.web.ui.internal.view.plan.actions.Action;

Action.STYLE_FLAT= STYLE_FLAT;
Action.STYLE_PUSH= STYLE_PUSH;
Action.STYLE_TOGGLE= STYLE_TOGGLE;
Action.STYLE_DROP_DOWN= STYLE_DROP_DOWN;
Action.STYLE_NOHOVER= STYLE_NOHOVER;
Action.STYLE_SHOW_AS_SELECTED= STYLE_SHOW_AS_SELECTED;
Action.STYLE_SHOW_AS_SINGLESELECTED= STYLE_SHOW_AS_SINGLESELECTED;

})();
