/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.IterationSelectionDialog"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("jazz.ui.ModeledTree"); //$NON-NLS-1$
dojo.require("jazz.ui.tree.IconItem"); //$NON-NLS-1$
dojo.require("jazz.util.html"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.client.projectarea"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
	var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

	dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.IterationSelectionDialog", null, { //$NON-NLS-1$
	
		constructor: function(params){
			var onOk = dojo.hitch(this, function(args){
				params.onOk(args);
				this.floatingPane.close();
			});
			var onCancel = dojo.hitch(this, function(){
				this.floatingPane.close();
			});
			
			this.contentWidget = new com.ibm.team.apt.web.ui.internal.view.plan.dialogs.IterationSelectionDialogContent({
				onOk: onOk,
				onCancel: onCancel,
				getIconClass: params.getIconClass,
				getModelId: params.getModelId,
				data: params.data,
				selection: params.selection
			});
			var widgetParams = { };
			widgetParams.primaryTitle= Messages.ITERATIONPLAN_ITERATION;
			widgetParams.contentNode = this.contentWidget.domNode;
			widgetParams.destroyContents = true;
			this.floatingPane= new jazz.ui.Dialog(widgetParams);
			this.contentWidget.init();
		}
	});
		
	dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.IterationSelectionDialogContent", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
			
			templateString: '<div style="padding: 1em 1em 1em 1em;">' + //$NON-NLS-1$
			'<div dojoAttachPoint="_treeNode" class="com-ibm-team-apt-web-ui-internal-view-plan-dialogs-IterationSelectionDialog" style="height: 20em; background-color: #FFFFFF; border: 1px solid #CCCCCC; overflow: auto;"></div>' + //$NON-NLS-1$
			'<span style="padding: 1em 0em; float: left;">' + //$NON-NLS-1$
			'<a href="#" dojoAttachPoint="_createIterationCmd">'+ Messages.PLAN_CREATE_ITERATION_CREATE + '</a>' +  //$NON-NLS-1$ //$NON-NLS-2$
			'</span>' + //$NON-NLS-1$
			'<span style="padding: 1em 0em; float: right;">' + //$NON-NLS-1$
			'<button dojoAttachPoint="_okCmd">OK</button>' + //$NON-NLS-1$
			'<button dojoAttachPoint="_cancelCmd">Cancel</button>' + //$NON-NLS-1$
			'</span>' + //$NON-NLS-1$
			' </div>', //$NON-NLS-1$
			
			constructor: function(params){
			
			},
			
			init: function() {
				
			},
			
			postCreate: function(){
				
				var tree= new jazz.ui.ModeledTree({
					model: this.data,
					createTreeItem: dojo.hitch(this, function(obj){
						return new jazz.ui.tree.IconItem({
							label: jazz.util.html.escape(obj.label),
							iconClass: this.getIconClass(obj),
							getId: dojo.hitch(this, this.getModelId, obj)
						});
					}),
					onDblClick: dojo.hitch(this, this._doOnOk),
					onEnter: dojo.hitch(this, this._doOnOk)
				});
				this._tree= tree;
				this._treeNode.appendChild(tree.domNode);
				
				this.connect(this._createIterationCmd, "onclick", this._doCreateIteration); //$NON-NLS-1$
				this.connect(this._okCmd, "onclick", this._doOnOk); //$NON-NLS-1$
				this.connect(this._cancelCmd, "onclick", this.onCancel); //$NON-NLS-1$
				
				if(this.selection && this.selection.length > 0) {
					for(var i = 0; i < this.selection.length; i++) {
						this._tree.expandTo(this.getModelId(this.selection[i]), this.getModelId);
						this._tree.setSelection(this._tree.getItem(this.getModelId(this.selection[i])));
					}
				}
			},
			
			_doOnOk: function(){
				var result = this._tree.getSelection();
				if (result && result.length > 0) {
					var id = result[0].getId();
					result= this._tree.getModelObject(id);
					this.onOk(result);
				}
			},
			
			_doCreateIteration: function(evt) {
				dojo.stopEvent(evt);
				this.onCancel(evt);
				
				var location= [];
				location.push(window.location.protocol);
				location.push("//"); //$NON-NLS-1$
				location.push(window.location.host);
				location.push("/jazz/admin"); //$NON-NLS-1$
				location.push(window.location.search);
				location.push("#action=com.ibm.team.process.editProjectArea&itemId=" + com.ibm.team.process.web.client.projectarea.getCurrentProjectArea().itemId); //$NON-NLS-1$
				location= location.join('');  //$NON-NLS-1$
				window.location= location;
			}
	});
	
})();
