/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.ColumnElementViewerItem"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.dnd.PlanItemDnDSource"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var doc= document;
var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var ViewModelViewerItem				= com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem;

var PlanningUtil		= com.ibm.team.apt.web.client.util;
var WorkItemDnDDSource	= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.WorkItemDnDDSource;

var PlanItemDnDSource	= com.ibm.team.apt.web.ui.internal.view.plan.dnd.PlanItemDnDSource;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.ColumnElementViewerItem", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem], {

	_columnElement: null,
	_dndSource: null,
	_content: null,
	_columnTable: null,
	_groupEntry: null,

	constructor: function(entry, parentItem, plannedItemsTab, viewer) {
		this._columnElement= entry.getElement();
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	isExpanded: function() {
		return true;
	},
	
	addNode: function(item) {
		this._content.appendChild(item.domNode);
	},
	
	removeNode: function(item) {
		this._content.removeChild(item.domNode);
	},

	// ---- ViewModelViewerItem implementation -----------------------------------------------------------------------------

	_createContainer: function() {
		var result= doc.createElement("td"); //$NON-NLS-1$
		dojo.addClass(result, "taskboardColumn"); //$NON-NLS-1$
		return result;
	},

	_createContent: function() {
		var localDoc= doc;
		this._columnTable= localDoc.createElement("table"); //$NON-NLS-1$
		dojo.addClass(this._columnTable, "taskboardColumnTable"); //$NON-NLS-1$
		this._content= localDoc.createElement("tbody"); //$NON-NLS-1$
		this._columnTable.appendChild(this._content);
		this.domNode.appendChild(this._columnTable);

		var column= this._columnElement.getColumn();
		if (column != null) {
			var headerRow= localDoc.createElement("tr"); //$NON-NLS-1$
			this._content.appendChild(headerRow);
			headerRow.appendChild(column.createCell());
		}
		
		this._dndSource= new PlanItemDnDSource(this.domNode, PlanItemDnDSource.constructorArgs(this, this._plannedItemsTab.getItemMovePolicy(), this._plannedItemsTab, this._content));
		
		var columnCount= this._columnElement.getRow().getColumnCount();
		var width= (100 / columnCount) + '%'; //$NON-NLS-1$
		this.domNode.style.width= width;

		var minWidth= 19;
		var fields= this.__getFields();
		minWidth= minWidth + (fields.length * 10);
		if (dojo.isSafari) {
			this.domNode.style.width= minWidth + "em"; //$NON-NLS-1$
		} else {			
			this.domNode.style.minWidth= minWidth + "em"; //$NON-NLS-1$
		}
	},

	_getTreeLevel: function() {
		return 0;
	},

	_insertChildItem: function(viewerItem, insertBefore) {
		if (viewerItem instanceof com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItem) {
			this._dndSource.insertNodes(false, [viewerItem]);
		} else {
			this._content.appendChild(viewerItem.domNode);			
		}
	},

	_getFirstChildNode: function() {
		return this._content.firstChild;
	},
	
	_updateContent: function() {
	},

	_dispose: function() {
		if (this._dndSource != null) {
			this._dndSource.destroy();
			this._dndSource= null;
		}
		
		this.inherited(arguments);
	},

	// ---- implementation -------------------------------------------------------------------------------------------------
	
	__getFields: function() {
		return this._entry.getTags(com.ibm.team.apt.ui.model.FieldTag);
	},

	__sentinel: null // terminates this class definition
});


})();
