/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.Columns"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.ImageClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanningClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil"); //$NON-NLS-1$
dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$
dojo.require("jazz.util.html"); //$NON-NLS-1$


dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var ImageClient			= com.ibm.team.apt.web.client.internal.ImageClient;
var WorkItemUtil		= com.ibm.team.workitem.web.client.util;
var WorkItemEditorUtil	= com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;

var PlanningUtil		= com.ibm.team.apt.web.client.util;
var PlanningClient		= com.ibm.team.apt.web.client.internal.PlanningClient;

var doc= document;
var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var CompleteDecorationUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/complete_ovr.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var DurationIconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/duration_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var EditIconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/edit.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var CreateItemIconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/create_workitem.gif"); //$NON-NLS-1$ //$NON-NLS-2$

function _defaultAttributeColumnCreator(workItemWidget) {
	var localDoc= doc;
	var result= localDoc.createElement("td"); //$NON-NLS-1$
	dojo.addClass(result, "attribute"); //$NON-NLS-1$
	dojo.addClass(result, this._type);
	
	var icon= this._getIcon(workItemWidget);
	if (icon != null) {
		var iconElement= localDoc.createElement("img"); //$NON-NLS-1$
		dojo.addClass(iconElement, "icon"); //$NON-NLS-1$
		iconElement.src= ImageClient.getImageUrl(icon);
		result.appendChild(iconElement);
	}

	var labelElement= localDoc.createElement("span"); //$NON-NLS-1$
	dojo.addClass(labelElement, "label"); //$NON-NLS-1$
	labelElement.appendChild(localDoc.createTextNode(this._getLabel(workItemWidget)));
	result.appendChild(labelElement);
	
	return result;
}

function _emptyCellCreator() {
	var result= doc.createElement("td"); //$NON-NLS-1$
	return result;
}

function _defaultHeaderCreator() {
	var localDoc= doc;
	var result= localDoc.createElement("td"); //$NON-NLS-1$
	dojo.addClass(result, "tableHeader"); //$NON-NLS-1$
	dojo.addClass(result, this._type);
	
	var icon= this._getIcon();
	if (icon != null) {
		var iconElement= localDoc.createElement("img"); //$NON-NLS-1$
		dojo.addClass(iconElement, "icon"); //$NON-NLS-1$
		iconElement.src= ImageClient.getImageUrl(icon);
		result.appendChild(iconElement);
	}

	var labelElement= localDoc.createElement("span"); //$NON-NLS-1$
	dojo.addClass(labelElement, "label"); //$NON-NLS-1$
	labelElement.appendChild(localDoc.createTextNode(this._getLabel()));
	result.appendChild(labelElement);
	
	return result;
}

dojo.mixin(com.ibm.team.apt.web.ui.internal.view.plan.planneditems.Columns,  {
	empty: {
		createCell: _defaultAttributeColumnCreator,
		
		_type: "empty", //$NON-NLS-1$
		_getIcon: function(workItemWidget) {
			return null;
		},
		_getLabel: function(workItemWidget) {
			return ""; //$NON-NLS-1$
		} 
	},

	marker: {
		createCell: function(workItemWidget) {
			var localDoc= doc;
			var result= localDoc.createElement("td"); //$NON-NLS-1$
			dojo.addClass(result, "info"); //$NON-NLS-1$

			var iconDiv= localDoc.createElement("div"); //$NON-NLS-1$
			dojo.addClass(iconDiv, "iconDiv"); //$NON-NLS-1$
			
			var outplaceReasons= workItemWidget.getOutplaceReasons();
			if (outplaceReasons != null && outplaceReasons.length > 0) {
				dojo.addClass(iconDiv, "OUTPLACE"); //$NON-NLS-1$
				new jazz.ui.HoverPopup({
					around: [iconDiv], //$NON-NLS-1$
					html: dojo.map(outplaceReasons, function(reason) {return jazz.util.html.escape(reason); } ).join("<br />"), //$NON-NLS-1$
					orientation: "R" //$NON-NLS-1$
				});
			} else {
				var planItem= workItemWidget.getPlanItem();
				
				var messages= [];

				var report= planItem.getCheckReport();
				if (report != null) {
					messages= messages.concat(report.getProblems());
				}
				
				messages= messages.concat(workItemWidget.getViewEntry().getTags(com.ibm.team.apt.ui.model.CustomMarkerTag));
				
				if (messages.length > 0) {
					messages.sort(function(a, b) {
						return -a.getSeverity().compareTo(b.getSeverity());
					});
				
					dojo.addClass(iconDiv, messages[0].getSeverity().getValue());

					var tooltipHtml= "<table class=\"com-ibm-team-apt\">"; //$NON-NLS-1$
					if (messages.length > 1) {
						tooltipHtml+= "<thead><tr><td colspan=\"2\">" + MSGS.PLANNEDITEMS_MULTIPLEMARKERS + "</td></tr></thead>"; //$NON-NLS-1$ //$NON-NLS-2$
					}
					dojo.forEach(messages, function(message) {
						tooltipHtml+= "<tr><td><div class=\"iconDiv " + message.getSeverity().getValue() +  "\"></div>"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
						tooltipHtml+= "</td><td>"; //$NON-NLS-1$
						tooltipHtml+= jazz.util.html.escape(message.getMessage()); //$NON-NLS-1$
						tooltipHtml+= "</td></tr>"; //$NON-NLS-1$
					});

					tooltipHtml+= "</table>"; //$NON-NLS-1$
					
					new jazz.ui.HoverPopup({
						around: [iconDiv], //$NON-NLS-1$
						html: tooltipHtml,
						orientation: "R" //$NON-NLS-1$
					});

				}
			}

			result.appendChild(iconDiv);
			return result;
		},
		createHeader: _emptyCellCreator
	},

	summary: {
		createCell: function(workItemWidget) {
			var localDoc= doc;
			var result= localDoc.createElement("td"); //$NON-NLS-1$
			dojo.addClass(result, "attribute"); //$NON-NLS-1$
			dojo.addClass(result, "summary"); //$NON-NLS-1$
			
			var iconContainer= localDoc.createElement("div"); //$NON-NLS-1$
			dojo.addClass(iconContainer, "icon"); //$NON-NLS-1$
			
			var iconElement= localDoc.createElement("img"); //$NON-NLS-1$
			dojo.addClass(iconElement, "typeIcon"); //$NON-NLS-1$
			iconElement.src= ImageClient.getImageUrl(workItemWidget.getPlanItem().getItemType().iconURL); // XXX iconUrl on workItemType is certainly not API
			iconContainer.appendChild(iconElement);

			var decorationElement= localDoc.createElement("img"); //$NON-NLS-1$
			dojo.addClass(decorationElement, "typeDecoration"); //$NON-NLS-1$
			decorationElement.src= CompleteDecorationUrl;
			iconContainer.appendChild(decorationElement);

			result.appendChild(iconContainer);
		
			var idLink= localDoc.createElement("a"); //$NON-NLS-1$
			idLink.href= "#openEditor"; //$NON-NLS-1$
			dojo.addClass(idLink, "label"); //$NON-NLS-1$
			idLink.title= MSGS.action_editMini;
			idLink.appendChild(localDoc.createTextNode(WorkItemEditorUtil.restoreTags(workItemWidget.getPlanItem().getSummary())));
			result.appendChild(idLink);
			
			return result;
		},
		createHeader: _emptyCellCreator
	},

	id: {
		createCell: function(workItemWidget) {
			var localDoc= doc;
			var idColumn= localDoc.createElement("td"); //$NON-NLS-1$
			dojo.addClass(idColumn, "id"); //$NON-NLS-1$

			var planItem= workItemWidget.getPlanItem();

			var idLink= localDoc.createElement("a"); //$NON-NLS-1$
			idLink.href= WorkItemUtil.getViewWorkItemUri(planItem.getId()); 		
			idLink.appendChild(localDoc.createTextNode(planItem.getId()));
			idLink.title= MSGS.action_edit;
			
			idColumn.appendChild(idLink);
			return idColumn;  		
		},
		createHeader: _emptyCellCreator
	},
	
	taskboardparent: {
		createCell: _emptyCellCreator,
		createHeader: _emptyCellCreator
	},
	
	todo: {
		createCell: _defaultHeaderCreator,
		
		_type: "todo", //$NON-NLS-1$
		_getIcon: function() {
			return "/jazz/web/com.ibm.team.apt.web/ui/internal/view/plan/images/state_open.gif"; //$NON-NLS-1$
		},
		_getLabel: function() {
			return MSGS.COLUMNS_HEADER_TODO;
		}
	},
	
	inpr: {
		createCell: _defaultHeaderCreator,
		
		_type: "inpr", //$NON-NLS-1$
		_getIcon: function() {
			return "/jazz/web/com.ibm.team.apt.web/ui/internal/view/plan/images/state_inprogress.gif"; //$NON-NLS-1$;
		},
		_getLabel: function() {
			return MSGS.COLUMNS_HEADER_INPROGRESS;
		}
	},
	
	done: {
		createCell: _defaultHeaderCreator,
		
		_type: "done", //$NON-NLS-1$
		_getIcon: function() {
			return "/jazz/web/com.ibm.team.apt.web/ui/internal/view/plan/images/state_closed.gif"; //$NON-NLS-1$;
		},
		_getLabel: function() {
			return MSGS.COLUMNS_HEADER_DONE;
		}
	},
	
	stateHeader: function(workflow, stateId) {
		var label= workflow.getStateLabel(stateId);
		var icon= workflow.getStateIcon(stateId);
		return {
			createCell: _defaultHeaderCreator,
			
			_type: "done", //$NON-NLS-1$
			_getIcon: function() {
				return icon;
			},
			_getLabel: function() {
				return label;
			}
		};
	}
});

})();
