/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2007, 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
 
dojo.provide("com.ibm.rational.cm.web.ui.view.filter.CqFilterCalendar");

dojo.require("dijit._Calendar");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.rational.cm.web.ui","cqQueryFilters");

dojo.declare(
	"com.ibm.rational.cm.web.ui.view.filter.CqFilterCalendar",
	dijit._Calendar, 
	{	
		/*
			could be used if we use Dojo Markup to classify this widget
		*/
		widgetType: "CqFilterCalendar",	
		
		macrovalue: null,
		
		// Make sure the templateString is cleared out so it can be populated using the
		// templatePath.  Otherwise, templateString from superclass is used.
		templateString: null,
		templatePath: dojo.moduleUrl("com.ibm.rational.cm.web", "ui/view/filter/templates/CqCalendar.html"),
		
		setValue: function(value){
			if(com.ibm.rational.cm.web.ui.view.filter.isDateMacro(value)){
				this.macrovalue = value;
			}else{
				this.inherited('setValue', arguments);
			}
		},
		
		_onYesterday: function(event){
			var YESTERDAY = com.ibm.rational.cm.web.ui.view.filter.DateMacros.YESTERDAY;
			this.setValue(YESTERDAY);
			this.onValueSelected(YESTERDAY);
		},
		
		_onToday: function(event){
			var TODAY = com.ibm.rational.cm.web.ui.view.filter.DateMacros.TODAY;
			this.setValue(TODAY);
			this.onValueSelected(TODAY);
		},
		
		_onTomorrow: function(event){
			var TOMORROW = com.ibm.rational.cm.web.ui.view.filter.DateMacros.TOMORROW;
			this.setValue(TOMORROW);		
			this.onValueSelected(TOMORROW);
		},
		
		postMixInProperties:function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui","cqQueryFilters");
			this.inherited("postMixInProperties", arguments);
		}		
	}
);

com.ibm.rational.cm.web.ui.view.filter.DateMacros = {
	YESTERDAY: "[YESTERDAY]",
	TODAY: "[TODAY]",
	TOMORROW: "[TOMORROW]"
};

com.ibm.rational.cm.web.ui.view.filter.isDateMacro = function(value){
	var DateMacros = com.ibm.rational.cm.web.ui.view.filter.DateMacros;
	if((value == DateMacros.YESTERDAY) || (value == DateMacros.TODAY) || (value == DateMacros.TOMORROW)){
		return true;
	}
	return false;
};