/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.cm.web.ui.view.navigation.RecentView");

dojo.require("com.ibm.rational.cm.web._base");
dojo.require("com.ibm.rational.cm.web.ui.view.navigation.ListView");

dojo.requireLocalization("com.ibm.rational.cm.web.ui", "FavoritesMessages");

(function(){

var MAXRECENTITEMS	= 5;

var cq = com.ibm.rational.cm.web;
var messages;

dojo.declare(
	"com.ibm.rational.cm.web.ui.view.navigation.RecentView",
	com.ibm.rational.cm.web.ui.view.navigation.ListView,
{
	postMixInProperties: function(){
		messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "FavoritesMessages");
		this.inherited(arguments);
	},

	addRecent: function(props){
		var type = props.type;
		if (type == "FULL_TEXT") {	// we don't support FTS in recently viewed
			return;
		}
//		if(type != "LIST" && type != "RECORD"){ return; }
		var id = props.id;
		var item = this.getItem(id);
		var label = props.title;
		var recentItemHref = cq.getActionHref(type, id, label) + "&isRefresh=false";
		var self = this;
		this.addItem({
			id: id,
			label: label,
			href: recentItemHref,
			iconUrl: cq.getIconUrl(type),
			buttonInfo: [
				{
					tooltip: messages.AddToFavorites,
					onClick: function(){
						dojo["require"]("com.ibm.rational.cm.web.ui.page.FavoritesController");
						com.ibm.rational.cm.favoritesController.addFavorite({
							type: type,
							title: self.getItem(id).label, // don't use props.title directly since it will be updated
							stableLocation: id,
							masterReplica: "<local>" // TODO : hard-coded
						});
					},
					iconClass: "add-favorite-command",
					hoverCommand: true
				}
			]
		});
				
		// remove items if the number of items exceeds 'maxNum'
		if(this._items.length > MAXRECENTITEMS){
			this._removeOldestItem();
		}
	},

	_removeOldestItem: function(){
		var oldestTime = new Date().getTime();
		var oldestId;
		var items = this._items;
		for(var i = 0, len = items.length; i < len; i++){
			if(items[i].touched < oldestTime){
				oldestTime = items[i].touched;
				oldestId = items[i].id;
			}
		}
		this.removeItem(oldestId);
	}
});

})();