/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.cm.web.ui.view.record.QuickInformationPart");
dojo.require("com.ibm.rational.cm.web._base");

dojo.require("jazz.client.xhr");
dojo.require("jazz.app.ResourceLink");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Toolbar");

dojo.requireLocalization("com.ibm.rational.cm.web.ui", "QuickInformationPart");

/*
 * This is a wrapper widget that shows the Approvals Section
 */
(function(){
	var cq = com.ibm.rational.cm.web;

    /* defineWidget */
    dojo.declare("com.ibm.rational.cm.web.ui.view.record.QuickInformationPart", 
				[dijit._Widget, dijit._Templated],
	{
		title: dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "QuickInformationPart").QuickInformation,
		widgetsInTemplate: true,
		_resourceLinks: [],
        templateString: '<div class="quickInformationPart">' +
	        				'<table class="quickInfoTitle"><tr>' +
								'<td dojoAttachPoint="_titleNode" width="100%">${title}</td>' + 
		        				'<td><div dojoType="dijit.Toolbar" dojoAttachPoint="_menuNode"></div></td>' +
							'</tr></table>' +
							'<div dojoAttachPoint="_noTask" class="quickInfoContent">' +
								dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "QuickInformationPart").NoWorkItems +
							'</div>' +
	        				'<div dojoAttachPoint="_tasksList" class="quickInfoContent">' +
	        				'</div>' +
						'</div>',
		postCreate: function(){
			this._createMenu();
		},
		
		uninitialize: function(){
			this._destroyMenu();
			this._removeLinks(); 
		},
		
		_createMenu: function(){
		},
		
		_destroyMenu: function(){
		},
		
		setRecordId: function(id){
			this.recordId = id;
			this.refresh();
		},
		
		setRecordTitle: function(title){
			this.recordTitle = title;
		},
		
		refresh: function(){
			this._getLinks();
		},

        resetWidget: function(){
			this._addLinks([]);
        },
		
		_getRecordURL: function(){
			// TODO: "&error=Invalid%20URI" is hack code to make internal link in LinksPart.js of Work Item component
			// work-around by linkHack.js 
			return cq.getURLforLink("RECORD", this.recordId); // + "&error=Invalid%20URI";
		},
		
		_getLinks: function(){
			this._addLinks([]);
		},
		
		_addLinks: function(linkDefs){
			// clear content
			this._removeLinks(); 
            dojox.data.dom.removeChildren(this._tasksList);
			// show/hide "No Work Items" 
			this._noTask.style.display = linkDefs.length == 0 ? "" : "none";
			// 
            for (var i = 0; i < linkDefs.length; i++) {
				this._addItem(linkDefs[i]);
			}
		},
		
		_removeLinks: function() {
			dojo.forEach(this._resourceLinks, function(link) { link.destroy(); }); 
			this._resourceLinks = [];
		},
		
		/*
		 * listDef : { id: , resourceUri: , label: , href: , buttonInfo: }  
		 */
		_addItem: function(listDef) {
			var self = this;
			var ul = document.createElement("ul");
			ul.className = "SummaryListElement";
			var row = document.createElement("li");
			row.className = "SummaryListElementItem";
			// button
			if(listDef.buttonInfo){
				var command = document.createElement("a");
				dojo.addClass(command, "artifactCommand");
				dojo.addClass(command, listDef.buttonInfo.iconClass);
				dojo.addClass(command, "artifactHoverCommand");
				command.title = listDef.buttonInfo.tooltip;
				if (dojo.isFunction(listDef.buttonInfo.onClick)) {
					this.connect(command, "onclick", listDef.buttonInfo.onClick);
				}
				row.appendChild(command);
			}
			// link
			var tabLink = document.createElement("a");
			tabLink.title = listDef.label;
			var resourceLinkArgs= { 
				uri: listDef.resourceUri,
				presentationUri: listDef.href,
				label: listDef.label,
				retainLinkText: true
			};
			this._resourceLinks.push(new jazz.app.ResourceLink(resourceLinkArgs, tabLink));
			row.appendChild(tabLink);
			ul.appendChild(row);			
			this._tasksList.appendChild(ul);
		}	
		
	});
    
})();
