/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.internal.Instant"); //$NON-NLS-1$

dojo.require("com.ibm.team.foundation.Assert"); //$NON-NLS-1$

(function() {

var Assert							= com.ibm.team.foundation.Assert;

dojo.declare("com.ibm.team.apt.client.internal.Instant", null, { //$NON-NLS-1$

	constructor: function(date) {
		this.__date= date;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getDate: function() {
		return this.__date;
	},

	getMilliseconds: function() {
		return this.__date.getTime();
	},

	before: function(instant) {
		return this.__date < instant.__date;
	},

	beforeEq: function(instant) {
		return this.__date <= instant.__date;
	},
	
	after: function(instant) {
		return this.__date > instant.__date;
	},

	afterEq: function(instant) {
		return this.__date >= instant.__date;
	},
	
	plus: function(duration) {
		return new com.ibm.team.apt.client.internal.Instant(new Date(this.__date.getTime() + duration.getMilliseconds()));
	},

	minus: function(duration) {
		return new com.ibm.team.apt.client.internal.Instant(new Date(this.__date.getTime() - duration.getMilliseconds()));
	},

	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;

		return this.__date.getTime() == other.__date.getTime();
	},
	
	compareTo: function(instant) {
		return this.__date.getTime() == instant.__date.getTime() ? 0 : this.__date < instant.__date ? -1 : 1;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
