/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.ui.structure.OwnerElement"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.PlanItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.ui.structure.GroupElement"); //$NON-NLS-1$

(function() {

var PlanItem						= com.ibm.team.apt.client.PlanItem;
var GroupElement					= com.ibm.team.apt.ui.structure.GroupElement;

var CATEGORY_TEAMMEMBER= 0;
var CATEGORY_OTHER= 1;
var CATEGORY_UNASSIGNED= 2;

dojo.declare("com.ibm.team.apt.ui.structure.OwnerElement", GroupElement, { //$NON-NLS-1$

	__contributor: null,
	__plan: null,

	constructor: function(contributor, plan) {
		this.__contributor= contributor;
		this.__plan= plan;
		
		var ownerValueSet= plan.findAttribute(PlanItem.OWNER).getValueSet();

		this.__category= CATEGORY_OTHER;
		if (contributor.itemId === ownerValueSet.nullValue.itemId) {
			this.__category= CATEGORY_UNASSIGNED;
		} else if (dojo.some(ownerValueSet.values, function(teamMember) { return contributor.itemId === teamMember.itemId; } )) {
			this.__category= CATEGORY_TEAMMEMBER;
		}
	},

	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;

		return this.__contributor.itemId === other.__contributor.itemId;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return this.__contributor.itemId;
	},

	getLabel: function() {
		return this.__contributor.label;
	},
	
	getElementKey: function() {
		return this.__contributor.itemId;
	},
	
	getValue: function() {
		return this.__contributor;
	},
	
	compareTo: function(other) {
		if (this.__category != other.__category)
			return this.__category - other.__category;
		
		return this.__contributor.label.localeCompare(other.__contributor.label);
	},
	
	canAdopt: function(planElement) {
		return planElement instanceof com.ibm.team.apt.client.PlanItem;
	},
	
	adopt: function(planItem) {
		planItem.setAttributeValue(PlanItem.OWNER, this.__contributor);
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
